*$ CREATE MGDRAW.FOR
*COPY MGDRAW
*                                                                      *
*=== mgdraw ===========================================================*
*                                                                      *
      SUBROUTINE MGDRAW ( ICODE, MREG )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
*
*----------------------------------------------------------------------*
*                                                                      *
*     Copyright (C) 1990-2006      by        Alfredo Ferrari           *
*     All Rights Reserved.                                             *
*                                                                      *
*                                                                      *
*     MaGnetic field trajectory DRAWing: actually this entry manages   *
*                                        all trajectory dumping for    *
*                                        drawing                       *
*                                                                      *
*     Created on   01 march 1990   by        Alfredo Ferrari           *
*                                              INFN - Milan            *
*     Last change  05-may-06       by        Alfredo Ferrari           *
*                                              INFN - Milan            *
*                                                                      *
*----------------------------------------------------------------------*
*
      INCLUDE '(CASLIM)'
      INCLUDE '(COMPUT)'
      INCLUDE '(SOURCM)'
      INCLUDE '(FHEAVY)'
      INCLUDE '(FLKSTK)'
      INCLUDE '(GENSTK)'
      INCLUDE '(MGDDCM)'
      INCLUDE '(PAPROP)'
      INCLUDE '(QUEMGD)'
      INCLUDE '(SUMCOU)'
      INCLUDE '(TRACKR)'
      INCLUDE '(SOUEVT)'
*
      DIMENSION DTQUEN ( MXTRCK, MAXQMG )
*
      CHARACTER*20 FILNAM
      LOGICAL LFCOPE
      SAVE LFCOPE
      DATA LFCOPE / .FALSE. /
      DIMENSION XTUP(10)
      REAL EDEPCON(6,2000)
      SAVE EDEPCON
      DATA EDEPCON /12000*0.0D0/
      REAL EDEPPOI(6,2000)
      SAVE EDEPPOI
      DATA EDEPPOI/12000*0.0D0/
      REAL ENERIN(2000)
      SAVE ENERIN
      DATA ENERIN/2000*0.0D0/
      REAL ENEROUT(2000)
      SAVE ENEROUT
      DATA ENEROUT/2000*0.0D0/
      REAL MOMINAR(12,2000)
      SAVE MOMINAR
      DATA MOMINAR/24000*0.0D0/
      REAL MOMOUTAR(12,2000)
      SAVE MOMOUTAR
      DATA MOMOUTAR/24000*0.0D0/
      INTEGER MOMINCO
      SAVE MOMINCO
      DATA MOMINCO/0/
      INTEGER MOMOUTCO
      SAVE MOMOUTCO
      DATA MOMOUTCO/0/
      REAL MOMTARAR(12,2000)
      SAVE MOMTARAR
      DATA MOMTARAR/24000*0.0D0/
      INTEGER MOMTARCO
      SAVE MOMTARCO
      DATA MOMTARCO/0/
      INTEGER TRE
      
      INTEGER IONA, IONZ, IONM
      
      INTEGER BESEEN
      INTEGER UNIQMAX
      SAVE UNIQMAX
      DATA UNIQMAX/0/
      INTEGER UNIQ(2000)
      SAVE UNIQ
      DATA UNIQ/2000*0.0D0/
*
*----------------------------------------------------------------------*
*                                                                      *
*     Icode = 1: call from Kaskad                                      *
*     Icode = 2: call from Emfsco                                      *
*     Icode = 3: call from Kasneu                                      *
*     Icode = 4: call from Kashea                                      *
*     Icode = 5: call from Kasoph                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
     &          'UNFORMATTED' )
      END IF
      
*      WRITE (IODRAW) NTRACK, MTRACK, JTRACK, SNGL (ETRACK),
*     &               SNGL (WTRACK)
*      WRITE (IODRAW) ( SNGL (XTRACK (I)), SNGL (YTRACK (I)),
*     &                 SNGL (ZTRACK (I)), I = 0, NTRACK ),
*     &               ( SNGL (DTRACK (I)), I = 1, MTRACK ),
*     &                 SNGL (CTRACK)
*  +-------------------------------------------------------------------*
*  |  Quenching is activated
      IF ( LQEMGD ) THEN
         RULLL = ZERZER
         CALL QUENMG ( ICODE, MREG, RULLL, DTQUEN )
*         WRITE (IODRAW) ( ( SNGL (DTQUEN (I,JBK)), I = 1, MTRACK ),
*     &                      JBK = 1, NQEMGD )
      END IF
*  |  End of quenching
*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     Boundary-(X)crossing DRAWing:                                    *
*                                                                      *
*     Icode = 1x: call from Kaskad                                     *
*             19: boundary crossing                                    *
*     Icode = 2x: call from Emfsco                                     *
*             29: boundary crossing                                    *
*     Icode = 3x: call from Kasneu                                     *
*             39: boundary crossing                                    *
*     Icode = 4x: call from Kashea                                     *
*             49: boundary crossing                                    *
*     Icode = 5x: call from Kasoph                                     *
*             59: boundary crossing                                    *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY BXDRAW ( ICODE, MREG, NEWREG, XSCO, YSCO, ZSCO )
      IF ((NEWREG-MREG).EQ.1 .AND. NEWREG.LE.5.AND.(Jtrack.EQ.-2)) THEN
	      CALL USRDCI(Jtrack,IONA,IONZ,IONM)
*      IF (IONA.EQ.11.AND.IONZ.EQ.6) THEN
	      WRITE(33,'(4(I5),4(F21.15))') Ncase,IONA,IONZ,MREG,
     +    Ptrack/DBLE(IONA),XSCO,YSCO,ZSCO
*       END IF
      END IF
      RETURN
*
*======================================================================*
*                                                                      *
*     Event End DRAWing:                                               *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY EEDRAW ( ICODE )
*      PRINT *,"EEDRAW:",Ncase," number of ions",UNIQMAX
*      PRINT *,"EEDRAW:",Ncase," unique array:"
*      DO I=1,UNIQMAX
*      PRINT *,"UNIQ[",I,"]=",UNIQ(I)
*      END DO
*      PRINT *,"EEDRAW:",Ncase," continious deposition:",EDEPCON
*      DO J=1,UNIQMAX
*      DO I=1,5
*      PRINT *,"EDEPCON[",I,"][",J,"]=",EDEPCON(I,J)
*      END DO
*      END DO
*      PRINT *,"EEDRAW:",Ncase," point deposition:",EDEPPOI
*      PRINT *,"EEDRAW:",Ncase," input energy:",ENERIN
*      PRINT *,"EEDRAW:",Ncase," output energy:",ENEROUT
*      PRINT *,"EEDRAW:",Ncase," Number of particles tout:",MOMTARCO
*      PRINT *,"EEDRAW:",Ncase," array of particles tout:",MOMTARAR
*      PRINT *,"EEDRAW:",Ncase," Number of particles din:",MOMINCO
*      PRINT *,"EEDRAW:",Ncase," Array of particles din:",MOMINAR
*      PRINT *,"EEDRAW:",Ncase," Number of particles dout:",MOMOUTCO
*      PRINT *,"EEDRAW:",Ncase," Array of particles dout:",MOMOUTAR
*      DO I=1,MOMTARCO
*      PRINT *,MOMTARCO,MOMTARAR
*      END DO
*       WRITE(34,*)'****************************************************'
*       WRITE(34,*)'**************THE END OF THE EVENT******************'
*       WRITE(34,*)'****************************************************'
      
      UNIQMAX=0
      DO I=1,200
      UNIQ(I)=0
      END DO  
  
      DO I=1,2000
      ENERIN(I)=0.0D0
      ENEROUT(I)=0.0D0
      END DO
      
      DO J=1,2000
      DO I=1,6
      EDEPCON(I,J)=0.0D0
      EDEPPOI(I,J)=0.0D0
      END DO
      END DO
      
      MOMINCO=0
      MOMOUTCO=0
      DO J=1,2000
         DO I=1,12
            MOMINAR(I,J)=0.0D0
            MOMOUTAR(I,J)=0.0D0
	 END DO
      END DO
      MOMTARCO=0
      DO J=1,2000
         DO I=1,12
            MOMTARAR(I,J)=0.0D0
	 END DO
      END DO
      PRINT *,"N=",Ncase
      TRE=Ncase-(INT(Ncase/1000)*1000)
      IF (TRE.EQ.0) THEN
*      CALL saveauto()
      END IF
      RETURN
*
*======================================================================*
*                                                                      *
*     ENergy deposition DRAWing:                                       *
*                                                                      *
*     Icode = 1x: call from Kaskad                                     *
*             10: elastic interaction recoil                           *
*             11: inelastic interaction recoil                         *
*             12: stopping particle                                    *
*             13: pseudo-neutron deposition                            *
*             14: escape                                               *
*             15: time kill                                            *
*     Icode = 2x: call from Emfsco                                     *
*             20: local energy deposition (i.e. photoelectric)         *
*             21: below threshold, iarg=1                              *
*             22: below threshold, iarg=2                              *
*             23: escape                                               *
*             24: time kill                                            *
*     Icode = 3x: call from Kasneu                                     *
*             30: target recoil                                        *
*             31: below threshold                                      *
*             32: escape                                               *
*             33: time kill                                            *
*     Icode = 4x: call from Kashea                                     *
*             40: escape                                               *
*             41: time kill                                            *
*             42: delta ray stack overflow                             *
*     Icode = 5x: call from Kasoph                                     *
*             50: optical photon absorption                            *
*             51: escape                                               *
*             52: time kill                                            *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY ENDRAW ( ICODE, MREG, RULL, XSCO, YSCO, ZSCO )
*      WRITE(34,*) Ncase,'From ENDRAW with code:',ICODE
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
     &          'UNFORMATTED' )
      END IF
*      WRITE (IODRAW)  0, ICODE, JTRACK, SNGL (ETRACK), SNGL (WTRACK)
*      WRITE (IODRAW)  SNGL (XSCO), SNGL (YSCO), SNGL (ZSCO), SNGL (RULL)
*  +-------------------------------------------------------------------*
*  |  Quenching is activated : calculate quenching factor
*  |  and store quenched energy in DTQUEN(1, jbk)
      IF ( LQEMGD ) THEN
         RULLL = RULL
         CALL QUENMG ( ICODE, MREG, RULLL, DTQUEN )
*         WRITE (IODRAW) ( SNGL (DTQUEN(1, JBK)), JBK = 1, NQEMGD )
      END IF
*  |  end quenching
*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     SOurce particle DRAWing:                                         *
*                                                                      *
*======================================================================*
*
      ENTRY SODRAW
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
     &          'UNFORMATTED' )
      END IF
*      WRITE (IODRAW) -NCASE, NPFLKA, NSTMAX, SNGL (TKESUM),
*     &                SNGL (WEIPRI)
*  +-------------------------------------------------------------------*
*  |  (Radioactive) isotope: it works only for 1 source particle on
*  |  the stack for the time being
      IF ( ILOFLK (NPFLKA) .GE. 100000 .AND. LRADDC (NPFLKA) ) THEN
         IARES  = MOD ( ILOFLK (NPFLKA), 100000  )  / 100
         IZRES  = MOD ( ILOFLK (NPFLKA), 10000000 ) / 100000
         IISRES = ILOFLK (NPFLKA) / 10000000
         IONID  = ILOFLK (NPFLKA)
*         WRITE (IODRAW) ( IONID,SNGL(-TKEFLK(I)),
*     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
*     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
*     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
*     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
*  |
*  +-------------------------------------------------------------------*
*  |  Patch for heavy ions: it works only for 1 source particle on
*  |  the stack for the time being
      ELSE IF ( ABS (ILOFLK (NPFLKA)) .GE. 10000 ) THEN
         IONID = ILOFLK (NPFLKA)
         CALL DCDION ( IONID )
*         WRITE (IODRAW) ( IONID,SNGL(TKEFLK(I)+AMNHEA(-IONID)),
*     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
*     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
*     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
*     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
*  |
*  +-------------------------------------------------------------------*
*  |
*      ELSE
*         WRITE (IODRAW) ( ILOFLK(I), SNGL (TKEFLK(I)+AM(ILOFLK(I))),
*     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
*     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
*     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
*     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
      END IF
*  |
*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     USer dependent DRAWing:                                          *
*                                                                      *
*     Icode = 10x: call from Kaskad                                    *
*             100: elastic   interaction secondaries                   *
*             101: inelastic interaction secondaries                   *
*             102: particle decay  secondaries                         *
*             103: delta ray  generation secondaries                   *
*             104: pair production secondaries                         *
*             105: bremsstrahlung  secondaries                         *
*             110: decay products                                      *
*     Icode = 20x: call from Emfsco                                    *
*             208: bremsstrahlung secondaries                          *
*             210: Moller secondaries                                  *
*             212: Bhabha secondaries                                  *
*             214: in-flight annihilation secondaries                  *
*             215: annihilation at rest   secondaries                  *
*             217: pair production        secondaries                  *
*             219: Compton scattering     secondaries                  *
*             221: photoelectric          secondaries                  *
*             225: Rayleigh scattering    secondaries                  *
*     Icode = 30x: call from Kasneu                                    *
*             300: interaction secondaries                             *
*     Icode = 40x: call from Kashea                                    *
*             400: delta ray  generation secondaries                   *
*  For all interactions secondaries are put on GENSTK common (kp=1,np) *
*  but for KASHEA delta ray generation where only the secondary elec-  *
*  tron is present and stacked on FLKSTK common for kp=npflka          *
*                                                                      *
*======================================================================*
*
      ENTRY USDRAW ( ICODE, MREG, XSCO, YSCO, ZSCO )
*      IF (ICODE.EQ.101.AND.MREG.EQ.1.AND.Jtrack.EQ.-2) THEN
*      CALL USRDCI(Jtrack,IONA,IONZ,IONM)
*      WRITE(34,*) 'At event:',Ncase,'MGDRAW called for ION',IONA,IONZ,
*     +  IONM,'with unique id',ISPUSR(MKBMX2),' with  nfragments:',npheav
*      WRITE(34,*) 'At event:',Ncase,'MGDRAW called for ION',IONA,IONZ,
*     +  IONM,'with unique id',ISPUSR(MKBMX2),' with  nsec:',np
*      DO I=1,npheav
*      WRITE(34,*)'     Fragment:',I,Ibheav(kheavy(i)),Icheav(kheavy(i))
*      END DO
*      END IF
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
     &          'UNFORMATTED' )
      END IF
* No output by default:
      RETURN
*=== End of subrutine Mgdraw ==========================================*
      END

